/* 
 * $Id: ConfigurationDao.java 3918 2012-06-20 20:48:33Z mitcje $
 * $URL: https://open.jira.com/svn/IKASAN/tags/ikasan-configuration-service-0.9.0-RC2/src/main/java/org/ikasan/configurationService/dao/ConfigurationDao.java $
 *
 * ====================================================================
 * Ikasan Enterprise Integration Platform
 * 
 * Distributed under the Modified BSD License.
 * Copyright notice: The copyright for this software and a full listing 
 * of individual contributors are as shown in the packaged copyright.txt 
 * file. 
 * 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 *
 *  - Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 *
 *  - Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 *
 *  - Neither the name of the ORGANIZATION nor the names of its contributors may
 *    be used to endorse or promote products derived from this software without 
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE 
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE 
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE 
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 */
package org.ikasan.configurationService.dao;

import org.ikasan.spec.configuration.Configuration;

/**
 * Configuration DAO interface defining the operations for interacting with
 * a runtime configuration.
 *
 * @author Ikasan Development Team
 */
public interface ConfigurationDao<CONFIGURATION_PARAMS>
{
    /**
     * Find and return the configuration entry instance for this configurationId.
     * If not found then 'null' is returned.
     * @param configurationId
     * @return Configuration
     */
    public Configuration<CONFIGURATION_PARAMS> findById(String id);

    /**
     * Create/update a configuration entry.
     * @param Configuration
     */
    public void save(Configuration<CONFIGURATION_PARAMS> configuration);

    /**
     * Delete a configuration entry.
     * @param Configuration
     */
    public void delete(Configuration<CONFIGURATION_PARAMS> configuration);
}
